using System;
using System.Drawing;
namespace NeuroX
{
	/// <summary>
	/// 
	/// </summary>
	public class NeuronSinusoid : NeuroX.Neuron
	{
		public NeuronSinusoid(Point p, double t, double f0, double output, bool bOptimize)
		{
						this.bOptimize = bOptimize;
			point = p;
			this.output = output;
			this.t = t;
			this.f0 = f0;
			InitializeNeuron();
			myPen = new Pen(Color.Brown, 2);
			drawBrush = new SolidBrush(Color.Brown);
		}

		public double t;
		public double f0;

		public override double CalculateOutput()
		{
			t = f0+t+input;
			output = Math.Sin(t);

			return 0;
		}
		public override void reset()
		{

		}
		public override void reset(Random r)
		{
		}
		
		public override void randomParam(Random r)
		{
			t = 0 + r.NextDouble()*(Math.PI/2);
			f0 = 0 + r.NextDouble()*(Math.PI/2);;
		}
		public override void standardParam()
		{	
		
			t=0;
			f0=0;
		
		}

		public override void Paint(System.Drawing.Graphics g)
		{
			base.Paint(g);
			g.DrawString("Sin",myFont,drawBrush,new Point(point.X,point.Y-15));
		}
		
	
		public override object Clone()
		{
			// TODO:  Add NeuronSinusoid.Clone implementation
			// TODO:  Add NeuronRandom.Clone implementation
			NeuronSinusoid ns = new NeuronSinusoid(point,t,f0,output,bOptimize);
			Clone(ns);
			return ns;
		}
	}
}
