using System;
using System.Drawing;

namespace NeuroX
{
	/// <summary>
	/// 
	/// </summary>
	public class NeuronRandom : NeuroX.Neuron
	{
		public NeuronRandom(Point p, double output, bool bOptimize, Random r)
		{
			this.r = r;
			this.bOptimize = bOptimize;
			point = p;
			this.output = output;
			InitializeNeuron();
			myPen = new Pen(Color.DarkGray, 2);
			drawBrush = new SolidBrush(Color.DarkGray);
		}
		private Random r;
		public override double CalculateOutput()
		{
			output = (r.NextDouble()-0.5)*2;
			return output;
		}
		public override void reset()
		{
			
		}
		public override void randomParam(Random r)
		{

		}
		public override void reset(Random r)
		{
		
		}	
		public override void standardParam()
		{

		}

		public override void Paint(System.Drawing.Graphics g)
		{
			base.Paint(g);
			g.DrawString("Rnd",myFont,drawBrush,new Point(point.X,point.Y-15));		
		}

	
		public override object Clone()
		{
			// TODO:  Add NeuronRandom.Clone implementation
			NeuronRandom nr = new NeuronRandom(point,output,bOptimize,r);
			Clone(nr);
			return nr;
		}
	}
}
