using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace WCLNeuronDiagramOpt
{
	/// <summary>
	/// Summary description for UserControl1.
	/// </summary>
	public class ucNeuronDiagrOpt : System.Windows.Forms.UserControl
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ucNeuronDiagrOpt(int number)
		{
			InitializeComponent();
			this.number = number;
			prevInt = (int)numericUpDownUserIntervals.Value;
			userPoints = new ArrayList();
			for (int i=0;i<(int)numericUpDownUserIntervals.Value;i++)
			{
				userPoints.Add(null);
			}
			yMin = -1.1;
			yMax = 1.1;
			netPoints = null;


			// TODO: Add any initialization after the InitForm call

		}

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panelY;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox tbActY;
		public int number;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox tbYMax;
		private System.Windows.Forms.TextBox tbYMin;
		private System.Windows.Forms.Panel panelDiagram;
		private System.Windows.Forms.Button btnUpdate;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label label4;
		public System.Windows.Forms.NumericUpDown numericUpDownUserIntervals;


		public void setDiagramParams(ArrayList netPoints, int min)
		{
			this.netPoints = netPoints.GetRange(min,(int)numericUpDownUserIntervals.Value);
			panelDiagram.Invalidate();
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.label4 = new System.Windows.Forms.Label();
			this.numericUpDownUserIntervals = new System.Windows.Forms.NumericUpDown();
			this.panelDiagram = new System.Windows.Forms.Panel();
			this.panelY = new System.Windows.Forms.Panel();
			this.label3 = new System.Windows.Forms.Label();
			this.tbActY = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.tbYMax = new System.Windows.Forms.TextBox();
			this.tbYMin = new System.Windows.Forms.TextBox();
			this.btnUpdate = new System.Windows.Forms.Button();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownUserIntervals)).BeginInit();
			this.panelY.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel1.Controls.Add(this.panel2);
			this.panel1.Controls.Add(this.panelDiagram);
			this.panel1.Controls.Add(this.panelY);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(512, 192);
			this.panel1.TabIndex = 0;
			// 
			// panel2
			// 
			this.panel2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.panel2.Controls.Add(this.label4);
			this.panel2.Controls.Add(this.numericUpDownUserIntervals);
			this.panel2.Location = new System.Drawing.Point(112, 144);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(400, 48);
			this.panel2.TabIndex = 14;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(160, 16);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(104, 16);
			this.label4.TabIndex = 1;
			this.label4.Text = "User intervals";
			// 
			// numericUpDownUserIntervals
			// 
			this.numericUpDownUserIntervals.Location = new System.Drawing.Point(264, 16);
			this.numericUpDownUserIntervals.Maximum = new System.Decimal(new int[] {
																					   200,
																					   0,
																					   0,
																					   0});
			this.numericUpDownUserIntervals.Minimum = new System.Decimal(new int[] {
																					   5,
																					   0,
																					   0,
																					   0});
			this.numericUpDownUserIntervals.Name = "numericUpDownUserIntervals";
			this.numericUpDownUserIntervals.TabIndex = 0;
			this.numericUpDownUserIntervals.Value = new System.Decimal(new int[] {
																					 20,
																					 0,
																					 0,
																					 0});
			this.numericUpDownUserIntervals.ValueChanged += new System.EventHandler(this.numericUpDownUserIntervals_ValueChanged);
			// 
			// panelDiagram
			// 
			this.panelDiagram.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panelDiagram.BackColor = System.Drawing.Color.White;
			this.panelDiagram.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panelDiagram.Location = new System.Drawing.Point(112, 0);
			this.panelDiagram.Name = "panelDiagram";
			this.panelDiagram.Size = new System.Drawing.Size(400, 144);
			this.panelDiagram.TabIndex = 2;
			this.panelDiagram.Paint += new System.Windows.Forms.PaintEventHandler(this.panelDiagram_Paint);
			this.panelDiagram.MouseDown += new System.Windows.Forms.MouseEventHandler(this.panelDiagram_MouseDown);
			// 
			// panelY
			// 
			this.panelY.Controls.Add(this.label3);
			this.panelY.Controls.Add(this.tbActY);
			this.panelY.Controls.Add(this.label2);
			this.panelY.Controls.Add(this.label1);
			this.panelY.Controls.Add(this.tbYMax);
			this.panelY.Controls.Add(this.tbYMin);
			this.panelY.Controls.Add(this.btnUpdate);
			this.panelY.Dock = System.Windows.Forms.DockStyle.Left;
			this.panelY.Location = new System.Drawing.Point(0, 0);
			this.panelY.Name = "panelY";
			this.panelY.Size = new System.Drawing.Size(112, 190);
			this.panelY.TabIndex = 3;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 40);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(40, 23);
			this.label3.TabIndex = 14;
			this.label3.Text = "Y act.";
			// 
			// tbActY
			// 
			this.tbActY.Location = new System.Drawing.Point(56, 40);
			this.tbActY.Name = "tbActY";
			this.tbActY.Size = new System.Drawing.Size(48, 20);
			this.tbActY.TabIndex = 13;
			this.tbActY.Text = "";
			this.tbActY.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 80);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(40, 16);
			this.label2.TabIndex = 11;
			this.label2.Text = "Y min";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(40, 23);
			this.label1.TabIndex = 10;
			this.label1.Text = "Y max";
			// 
			// tbYMax
			// 
			this.tbYMax.Location = new System.Drawing.Point(56, 8);
			this.tbYMax.Name = "tbYMax";
			this.tbYMax.Size = new System.Drawing.Size(48, 20);
			this.tbYMax.TabIndex = 9;
			this.tbYMax.Tag = "%f";
			this.tbYMax.Text = "1,1";
			this.tbYMax.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// tbYMin
			// 
			this.tbYMin.Location = new System.Drawing.Point(56, 80);
			this.tbYMin.Name = "tbYMin";
			this.tbYMin.Size = new System.Drawing.Size(48, 20);
			this.tbYMin.TabIndex = 8;
			this.tbYMin.Text = "-1,1";
			this.tbYMin.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// btnUpdate
			// 
			this.btnUpdate.Location = new System.Drawing.Point(24, 120);
			this.btnUpdate.Name = "btnUpdate";
			this.btnUpdate.Size = new System.Drawing.Size(56, 23);
			this.btnUpdate.TabIndex = 13;
			this.btnUpdate.Text = "Update";
			this.btnUpdate.Click += new System.EventHandler(this.btnUpdate_Click);
			// 
			// ucNeuronDiagrOpt
			// 
			this.Controls.Add(this.panel1);
			this.Name = "ucNeuronDiagrOpt";
			this.Size = new System.Drawing.Size(512, 192);
			this.Load += new System.EventHandler(this.ucNeuronDiagrOpt_Load);
			this.panel1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownUserIntervals)).EndInit();
			this.panelY.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void yMax_TextChanged(object sender, System.EventArgs e)
		{
		
		}
		
		public double yMin;
		public double yMax;
		private static int offsetX = 0; //ofsset of 0 on x axis
		
		private void drawPoint(Graphics g,Brush b,int x, double y)
		{
			double xInterval = (double)(panelDiagram.Width-offsetX)/(double)(1+(int) numericUpDownUserIntervals.Value);
			double yInterval = (double)panelDiagram.Height/(yMax-yMin);
			g.FillEllipse(b,(float)((double)x*xInterval+offsetX-2),(float)(panelDiagram.Height-((y-yMin)*yInterval)-2),4,4);

		}
		private void panelDiagram_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{

			
			Graphics myGraphics = e.Graphics;
			Pen axis = new Pen(Color.Black,2);
			SolidBrush brUserPoint = new SolidBrush(Color.Red);
			SolidBrush brNetPoint = new SolidBrush(Color.Blue);
			SolidBrush braxisPoint = new SolidBrush(Color.Black);
			myGraphics.DrawLine(axis,0+offsetX,0,0+offsetX,panelDiagram.Height); // y axis
			double unity = panelDiagram.Height/(yMax-yMin);
	
		
			if (yMin*yMax < 0) // oposite signs, we can draw x- axis
			{
				int posXax = panelDiagram.Height - (int)(unity*-yMin);
				myGraphics.DrawLine(axis,0,posXax,panelDiagram.Width,posXax);
			}
			
			for (int i=0;i<(int) numericUpDownUserIntervals.Value;i++)
			{
				drawPoint(myGraphics,braxisPoint,i+1,0);
				if (userPoints[i]!= null) drawPoint(myGraphics,brUserPoint,i+1,(double)userPoints[i]);
				if (netPoints != null)
				{
					drawPoint(myGraphics,brNetPoint,i+1,(double)netPoints[i]);
				}
			}

		}
		private ArrayList userPoints;
		public ArrayList netPoints;

		private void ucNeuronDiagrOpt_Load(object sender, System.EventArgs e)
		{
		
		}
	
		private int nPointAct;
		private void panelDiagram_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			double xInterval = (double)(panelDiagram.Width-offsetX)/(double)(1+(int) numericUpDownUserIntervals.Value);
			double yInterval = (double)panelDiagram.Height/(yMax-yMin);
			int numb = (int)((double)(e.X-offsetX-xInterval/2.0)/xInterval);
			if (numb >= userPoints.Count) return;
			userPoints[numb] = (double)(yMin + (panelDiagram.Height-e.Y)/yInterval);
			nPointAct = numb;
			tbActY.Text = Convert.ToString(userPoints[numb]);

			panelDiagram.Invalidate();


		}

		private void btnUpdate_Click(object sender, System.EventArgs e)
		{

			if (nPointAct < userPoints.Count && tbActY.Text!="")
			{
				userPoints[nPointAct] = Convert.ToDouble(tbActY.Text);
				
			}
			yMin = Convert.ToDouble(tbYMin.Text);
			yMax = Convert.ToDouble(tbYMax.Text);
			panelDiagram.Invalidate();

		}

		public double getNetowrkError(ArrayList testPoints, int min)
		{
//			if (testPoints.Count != max-min+1)
//			{
//				MessageBox.Show(Convert.ToString(userPoints.Count)+":"+Convert.ToString(max-min+1));
//				return -1.0;
//			}
			double error = 0;
			int j=0;
			for (int i=min;i<min+(int)numericUpDownUserIntervals.Value;i++)
			{
				if (userPoints[j]!=null)
					error+= Math.Pow(Math.Abs((double)testPoints[i]-(double)userPoints[j]),2);
				j++;
			}
			return error;
		}

		protected override void OnPaintBackground(System.Windows.Forms.PaintEventArgs pevent)
		{
			panelDiagram.Invalidate();
		
		}
		private int prevInt;
		private void numericUpDownUserIntervals_ValueChanged(object sender, System.EventArgs e)
		{
			netPoints = null;
			if (prevInt < (int)numericUpDownUserIntervals.Value) 
				for (int i=0;i<(int)numericUpDownUserIntervals.Value - prevInt;i++)
					userPoints.Add(null);

			else
				for (int i=0;i<prevInt -(int)numericUpDownUserIntervals.Value;i++)
					userPoints.RemoveAt(userPoints.Count-1);
			prevInt = (int)numericUpDownUserIntervals.Value;
			panelDiagram.Invalidate();
		}
	}
}
